//+------------------------------------------------------------------+
//|                                    HMA - Market Rotation v1.1.mq4 |
//|                                         Copyright  2006, Ogeima |
//|                                             ph_bresson@yahoo.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Ogeima"
#property link      "ph_bresson@yahoo.com"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 LimeGreen
#property indicator_color2 Red

//---- input parameters
extern int  HMA_1 =  60;
extern int  HMA_2 =  80;
//---- buffers
double ExtMapBuffer1[];//Up
double ExtMapBuffer2[];//Dn

double  direction;
datetime       dt;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   IndicatorBuffers(2);
   IndicatorDigits(Digits);
   SetIndexStyle(0,DRAW_ARROW,EMPTY,3);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(1,DRAW_ARROW,EMPTY,3);
   SetIndexBuffer(1,ExtMapBuffer2);
   IndicatorShortName("HMA - Market Rotation ("+HMA_1+","+HMA_2+")");
   direction   =  0; 
   dt=CurTime();
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   int shift, counted_bars=IndicatorCounted();
   if ( counted_bars < 0 )  return(-1);
   if ( counted_bars > 0 )  counted_bars--;
   int limit=Bars-counted_bars-1;
   
   double   hma1diff,hma2_0,hma2diff;

   if(NewBar()){
      for(shift=limit;shift>=0;shift--){	
         hma1diff =  iCustom(Symbol(),NULL,"HMA - Light v1.0",HMA_1,0,shift)  -  iCustom(Symbol(),NULL,"HMA - Light v1.0",HMA_1,0,shift+1);
         hma2_0  =  iCustom(Symbol(),NULL,"HMA - Light v1.0",HMA_2,0,shift);
         hma2diff =  hma2_0 - iCustom(Symbol(),NULL,"HMA - Light v1.0",HMA_2,0,shift+1);
         if(direction !=   1  && hma1diff > 0   && hma2diff > 0){
            ExtMapBuffer1[shift] =  hma2_0;
            direction            =  1;
         }
         else
         if(direction !=   -1 && hma1diff < 0   && hma2diff < 0){
            ExtMapBuffer2[shift] =  hma2_0;
            direction            =  -1;
         }
      }//end for(shift=limit;shift>=start;shift--){	
   }//end    if(NewBar()){
}//end start()
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
bool NewBar()
{
   static datetime dt = 0;
   
   if (Time[0] != dt)
   {
      dt = Time[0];
      return(true);
   }
   return(false);
}
//+------------------------------------------------------------------+